#include "chess.h"
#include "data.h"
#include "weights.h"

/*
    Absolute insufficient material draws
	KK KmK 

	3m > 2R > Q

	N[open] > B[open]
	B[end]  > N[end]

	m = 4p in open, 3p in middle and 2.5p in end

	null move being ok as long as 1 major piece exists
	KS being scaled according to opponent force
				Q	R	B	N
	force:		12  5   3   3
	donull:
	advantage:	7   4   3   3

*/
int cBOARD::eval_mat(void){
    
	assert(isok()==0);
	assert((board.control[board.pieces[side][0]] & mask[side]) == 0);
	
	int s, m1, m2, md, ms, t1, t2, t3, t4, i, sq;

    m1 = material[side];
	m2 = material[xside];

	ms = m1+m2; // material sum
	md = m1-m2; // material difference

	if(ms < 651){
		if(ms == 0) return 0; // lone kings
		if(ms == PAWN_VAL) return find_pawn(); // works mostly but sure there are bugs and holes
		if(ms == 325) return 0; // k[b/n] vs k
		if(ms == 650 && md == 0) return 0; // k b/n  vs k b/n 
	}
	
	
	piece_count[WHITE][PAWN] = 0;
    piece_count[WHITE][KNIGHT] = 0;
    piece_count[WHITE][BISHOP] = 0;
    piece_count[WHITE][ROOK] = 0;
    piece_count[WHITE][QUEEN] = 0;
    
    piece_count[BLACK][PAWN] = 0;
    piece_count[BLACK][KNIGHT] = 0;
    piece_count[BLACK][BISHOP] = 0;
    piece_count[BLACK][ROOK] = 0;
    piece_count[BLACK][QUEEN] = 0;

    
	i = 1;
	do{
        if((sq = pieces[WHITE][i]) & 0x88);
        else{
            t1 = square[sq].ptype;
            piece_count[WHITE][t1]++;
        }
        if(i == 15) break;
        i++;
	}while(true);
    
	i = 1;
	do{
        if((sq = pieces[BLACK][i]) & 0x88);
        else{
            t1 = square[sq].ptype;
            piece_count[BLACK][t1]++;
        }
        if(i == 15) break;
        i++;
	}while(true);

	//int canwin[2] = {0,0};
	
	/*
	if(piece_count[side][PAWN]+piece_count[xside][PAWN] == 0){
		return md + 20*(pcsq[KING][side][pieces[side][KING]] - pcsq[KING][xside][pieces[xside][KING]]);
	}//*/
	

	minors[WHITE] =	piece_count[WHITE][KNIGHT] + piece_count[WHITE][BISHOP];
	minors[BLACK] =	piece_count[BLACK][KNIGHT] + piece_count[BLACK][BISHOP];
	majors[WHITE] =	piece_count[WHITE][ROOK] + piece_count[WHITE][QUEEN];
	majors[BLACK] =	piece_count[BLACK][ROOK] + piece_count[BLACK][QUEEN];

	//
	// more theoretical? draw stuff here
	//
	//  this is missing eg., knight vs. pawn ie., canwin code ???
	/*826c&& ms != 975
	if(ms < 1326 && piece_count[side][PAWN]+piece_count[xside][PAWN] == 0){
		if(md > -326 && md < 326) return 0;
		if(ms == 650 && md != 0)
			//return 20*(pcsq[KING][side][pieces[side][KING]] - pcsq[KING][xside][pieces[xside][KING]]);
			if(piece_count[side][KNIGHT]|piece_count[xside][KNIGHT]) return 0;
	}//*/