#include "chess.h"
#include "data.h"
#include "moves.h"
#include "gen.h"

void cMOVELIST::gencap(){
    int sq, pc = 0;
    nextmove[ply] = nextmove[ply-1];
    if(side == WHITE){
        do{
            sq = board.pieces[WHITE][pc];
            if((sq & 0x88) == 0){
                switch(board.square[sq].ptype){
                    case KING: gencapwk(sq);
                    break;
                    case QUEEN: gencapwq(sq);
                    break;
                    case ROOK: gencapwr(sq);
                    break;
                    case BISHOP: gencapwb(sq);
                    break;
                    case KNIGHT: gencapwn(sq);
                    break;
                    case PAWN: gencapwp(sq);
                    break;
                    case EMPTY:  
                    cout << "ply:" 
                    << ply <<" no white piece to gencap moves for at " 
                    << sq << " ";
                    board.display();
                    //board.gamestack.top().to_string();
                    getchar();
                    break;
                }
            }
            if(pc == 15) break;
            pc++;
        }while(1);
    }
    else{
        do{
            sq = board.pieces[BLACK][pc];
            if((sq & 0x88) == 0){
                switch(board.square[sq].ptype){
                    case KING: gencapbk(sq);
                    break;
                    case QUEEN: gencapbq(sq);
                    break;
                    case ROOK: gencapbr(sq);
                    break;
                    case BISHOP: gencapbb(sq);
                    break;
                    case KNIGHT: gencapbn(sq);
                    break;
                    case PAWN: gencapbp(sq);
                    break;
                    case EMPTY: 
                    cout << "ply:" << ply 
                    <<" no black piece to gencap moves for at " << sq << " ";
                    board.display();
                    //cMOVE m = board.gamestack.top();
                    //m.print();
                    getchar(); 
                    break;
                }
            }
            if(pc == 15) break;
            pc++;
        }while(1);
    }
}

/*  as a rule: search is brutish, trying everything, therfore it
*   it encounters every and all sorts of situations, therfore
*   'as a rule' :
*   a major must move if enprise, regardless of protection simply
*   because 12/16 pieces liable to attack it are of lesser value
*   *interposing moves excepted
*   for a minor - 8/16 [pawns] are of lesser value, against which
*   'defense' is of no use, and 8/16 could be warded off by:
*   a- moving or b- interposing c- defending. Hence only 25% of attacks are answered
*   with defense - so as a rule: MOVE
*/
void gencapwk(int from){
    int dest, i = 0;
    do{
        dest = from + delta[i];
        if((dest & OFFBOARD) == 0 && (board.control[dest] & 0xffff0000) == 0){
            if(board.square[dest].color == BLACK)
                tree.addmove(from, dest, CAPTURE, capval[BASECAPSCORE+board.square[dest].ptype]); 
        }
        if(i == 7) break;
        i++;
    }while(1);
    //* 
    if(castle & 1)
        if((board.control[116] & 0xffff0000) == 0)
            if(board.square[117].isempty())
                if((board.control[117] & 0xffff0000) == 0)
                    if(board.square[118].isempty())          
                        if((board.control[118] & 0xffff0000) == 0)
                            tree.addmove(from, 118, CASTLEK, CASTLES);
    if(castle & 2)
        if((board.control[116] & 0xffff0000) == 0)
            if(board.square[115].isempty())
                if((board.control[115] & 0xffff0000) == 0)
                    if(board.square[114].isempty())          
                        if((board.control[114] & 0xffff0000) == 0)
                            if(board.square[113].isempty())
                                tree.addmove(from, 114, CASTLEQ, CASTLES);
    //*/
}

void gencapbk(int from){
    int dest, i = 0;
    do{
        dest = from + delta[i];
        if((dest & OFFBOARD) == 0 && (board.control[dest] & 0x0000ffff) == 0){
            if(board.square[dest].color == WHITE)
                tree.addmove(from, dest, CAPTURE, BASECAPSCORE+capval[board.square[dest].ptype]); 
        }
        if(i == 7) break;
        i++;
    }while(1);
    //*
    if(castle & 4)
        if((board.control[4] & 0x0000ffff) == 0)
            if(board.square[5].isempty())
                if((board.control[5] & 0x0000ffff) == 0)
                    if(board.square[6].isempty())          
                        if((board.control[6] & 0x0000ffff) == 0)
                            tree.addmove(from, 6, CASTLEK, CASTLES);
    if(castle & 8)
        if((board.control[4] & 0x0000ffff) == 0)
            if(board.square[3].isempty())
                if((board.control[3] & 0x0000ffff) == 0)
                    if(board.square[2].isempty())          
                        if((board.control[2] & 0x0000ffff) == 0)
                            if(board.square[1].isempty())
                                tree.addmove(from, 2, CASTLEQ, CASTLES);
    //*/
}

void gencapwq(int from){
    int dest, dlta, bs = BASECAPSCORE, s, i = 0;
    if(board.control[from] & 0xffff0000)
        bs += FLIGHTQ;//capval[QUEEN]; // RULE: move it or lose it
    do{
        dlta = delta[i];
        dest = from + dlta;
        while((dest & OFFBOARD)==0){
            if(board.square[dest].color == WHITE) break;
            if(board.square[dest].color == BLACK){  // captures
                s = capval[board.square[dest].ptype]; // RULE: we win
                if(board.control[dest] & 0xffff0000) // protected
                    s -= FRIGHTQ; // RULE: we lose piece
                tree.addmove(from, dest, CAPTURE, bs + s);
                break;
            }
            dest += dlta;
        }
        if(i == 7) break;
        i++;
    }while(1);
}

void gencapbq(int from){
    int dest, dlta, bs = BASECAPSCORE, s, i = 0;
    if(board.control[from] & 0x0000ffff)
        bs += FLIGHTQ;//capval[QUEEN]; // RULE: move it or lose it
    do{
        dlta = delta[i];
        dest = from + dlta;
        while((dest & OFFBOARD)==0){
            if(board.square[dest].color == BLACK) break;
            if(board.square[dest].color == WHITE){  // captures
                s = capval[board.square[dest].ptype];
                if(board.control[dest] & 0x0000ffff) // unprotected
                    s -= FRIGHTQ; 
                tree.addmove(from, dest, CAPTURE, bs + s);
                break;
            }
            dest += dlta;
        }
        if(i == 7) break;
        i++;
    }while(1);
}

void gencapwr(int from){
    int dest, dlta, bs = BASECAPSCORE, s, i = 4;
    if(board.control[from] & 0xffff0000)
        bs += FLIGHTR;//capval[ROOK]; // RULE: move it or lose it
    do{
        dlta = delta[i];
        dest = from + dlta;
        while((dest & OFFBOARD)==0){
            if(board.square[dest].color == WHITE) break;
            if(board.square[dest].color == BLACK){  // captures
                s = capval[board.square[dest].ptype];
                if(board.control[dest] & 0xffff0000) // protected
                    s -= FRIGHTR; /// 10
                tree.addmove(from, dest, CAPTURE, bs + s);
                break;
            }
            dest += dlta;
        }
        if(i == 7) break;
        i++;
    }while(1);
}

void gencapbr(int from){
    int dest, dlta, bs = BASECAPSCORE, s, i = 4;
    if(board.control[from] & 0x0000ffff)
        bs += FLIGHTR;//capval[ROOK]; // RULE: move it or lose it
    do{
        dlta = delta[i];
        dest = from + dlta;
        while((dest & OFFBOARD)==0){
            if(board.square[dest].color == BLACK) break;
            if(board.square[dest].color == WHITE){  // captures
                s = capval[board.square[dest].ptype];
                if(board.control[dest] & 0x0000ffff) // protected
                    s -= FRIGHTR; /// 10 
                tree.addmove(from, dest, CAPTURE, bs + s);
                break;
            }
            dest += dlta;
        }
        if(i == 7) break;
        i++;
    }while(1);
}

void gencapwb(int from){
    int dest, dlta, bs = BASECAPSCORE, s, i = 0;
    if(board.control[from] & 0xffff0000) bs += FLIGHTM; 
    do{
        dlta = delta[i];
        dest = from + dlta;
        while((dest & OFFBOARD)==0){
            if(board.square[dest].color == WHITE) break;
            if(board.square[dest].color == BLACK){  // captures
                s = capval[board.square[dest].ptype];
                if(board.control[dest] & 0xffff0000) // protected
                    s -= FRIGHTM; /// 10 
                tree.addmove(from, dest, CAPTURE, bs + s);
                break;
            }
            dest += dlta;
        }
        if(i == 3) break;
        i++;
    }while(1);
}

void gencapbb(int from){
    int dest, dlta, bs = BASECAPSCORE, s, i = 0;
    if(board.control[from] & 0x0000ffff) bs += FLIGHTM;//capval[BISHOP];
    do{
        dlta = delta[i];
        dest = from + dlta;
        while((dest & OFFBOARD)==0){
            if(board.square[dest].color == BLACK) break;
            if(board.square[dest].color == WHITE){  // captures
                s = capval[board.square[dest].ptype];
                if(board.control[dest] & 0x0000ffff) // protected
                    s -= FRIGHTM; /// 10 
                tree.addmove(from, dest, CAPTURE, bs + s);
                break;
            }
            dest += dlta;
        }
        if(i == 3) break;
        i++;
    }while(1);
}

void gencapwn(int from){
    int dest, bs = BASECAPSCORE, s, i = 8;
    if(board.control[from] & 0xffff0000) bs += FLIGHTM;
    do{
        dest = from + delta[i];
        if(dest & OFFBOARD);
        else{
            if(board.square[dest].color == BLACK){
                s = capval[board.square[dest].ptype];
                if(board.control[dest] & 0xffff0000) 
                    s -= FRIGHTM; /// 10 
                tree.addmove(from, dest, CAPTURE, bs + s);
            }
        }
        if(i == 15) break;
        i++;
    }while(1);
}

void gencapbn(int from){
    int dest, bs = BASECAPSCORE, s, i = 8;
    if(board.control[from] & 0x0000ffff) bs += FLIGHTM;
    do{
        dest = from + delta[i];
        if(dest & OFFBOARD);
        else{
            if(board.square[dest].color == WHITE){
                s = capval[board.square[dest].ptype];
                if(board.control[dest] & 0x0000ffff) 
                    s -= FRIGHTM;  
                tree.addmove(from, dest, CAPTURE, bs + s);
            }
        }
        if(i == 15) break;
        i++;
    }while(1);
}

void gencapwp(int from){
    int s; // 40
	if(from < 24 && board.square[from - 16].isempty()){
		//if(from < 24){
			tree.addmove(from, from-16, PROMO2Q, PROMO2QSCORE);
			//tree.addmove(from, from-16, PROMO2R, UNDERPROMOTE);
			//tree.addmove(from, from-16, PROMO2B, UNDERPROMOTE);
			//tree.addmove(from, from-16, PROMO2N, UNDERPROMOTE);
		//}else tree.addmove(from, from-16, SINGLE, 0);
	}    
    if(((from-17)&0x88)==0 && board.square[from-17].color == BLACK){
        s = capval[board.square[from-17].ptype];
        if(board.control[from - 17] & 0xffff0000) 
            s -= FRIGHTP; /// 10
        if(from<24){
            tree.addmove(from, from-17, PROMOXQ, PROMO2QSCORE+s);
            //tree.addmove(from, from-17, PROMOXR, UNDERPROMOTE+s);
            //tree.addmove(from, from-17, PROMOXB, UNDERPROMOTE+s);
            //tree.addmove(from, from-17, PROMOXN, UNDERPROMOTE+s);
        }    
        else tree.addmove(from, from-17, CAPTURE, s + BASECAPSCORE);
    }
    if(((from-15)&0x88)==0 && board.square[from-15].color == BLACK){
        s = capval[board.square[from-15].ptype];
        if(board.control[from - 15] & 0xffff0000) 
            s -= FRIGHTP; /// 10
        if(from<24){
            tree.addmove(from, from-15, PROMOXQ, PROMO2QSCORE+s);
            //tree.addmove(from, from-15, PROMOXR, UNDERPROMOTE+s);
            //tree.addmove(from, from-15, PROMOXB, UNDERPROMOTE+s);
            //tree.addmove(from, from-15, PROMOXN, UNDERPROMOTE+s);
        }    
        else tree.addmove(from, from-15, CAPTURE, s + BASECAPSCORE);
    }
    if(enpassant)
        if(enpassant == from-17 || enpassant == from-15){
            s = PAWN_VAL + BASECAPSCORE;
            if(board.control[enpassant] & 0xffff0000) s -= FRIGHTP;
            tree.addmove(from, enpassant, ENPASSANT, s);
        }
}   
    
void gencapbp(int from){
    int s; // 79
	if(from > 95 && board.square[from + 16].isempty()){
		//if(from > 95){
			tree.addmove(from, from+16, PROMO2Q, PROMO2QSCORE);
			//tree.addmove(from, from+16, PROMO2R, UNDERPROMOTE);
			//tree.addmove(from, from+16, PROMO2B, UNDERPROMOTE);
			//tree.addmove(from, from+16, PROMO2N, UNDERPROMOTE);
		//}else tree.addmove(from, from+16, SINGLE, 0);
	}    
    if(((from+17)&0x88)==0 && board.square[from+17].color == WHITE){
        s = capval[board.square[from+17].ptype];
        if(board.control[from + 17] & 0x0000ffff) 
            s -= FRIGHTP; /// 10
        if(from>95){
            tree.addmove(from, from+17, PROMOXQ, PROMO2QSCORE+s);
            //tree.addmove(from, from+17, PROMOXR, UNDERPROMOTE+s);
            //tree.addmove(from, from+17, PROMOXB, UNDERPROMOTE+s);
            //tree.addmove(from, from+17, PROMOXN, UNDERPROMOTE+s);
        }    
        else tree.addmove(from, from+17, CAPTURE, s + BASECAPSCORE);
    }
    if(((from+15)&0x88)==0 && board.square[from+15].color == WHITE){
        s = capval[board.square[from+15].ptype];
        if(board.control[from + 15] & 0x0000ffff) 
            s -= FRIGHTP; /// 10
        if(from>95){
            tree.addmove(from, from+15, PROMOXQ, PROMO2QSCORE+s);
            //tree.addmove(from, from+15, PROMOXR, UNDERPROMOTE+s);
            //tree.addmove(from, from+15, PROMOXB, UNDERPROMOTE+s);
            //tree.addmove(from, from+15, PROMOXN, UNDERPROMOTE+s);
        }    
        else tree.addmove(from, from+15, CAPTURE, s + BASECAPSCORE);
    }
    if(enpassant)
        if(enpassant == from+17 || enpassant == from+15){
            s = PAWN_VAL + BASECAPSCORE;
            if(board.control[enpassant] & 0x0000ffff) s -= FRIGHTP;
            tree.addmove(from, enpassant, ENPASSANT, s);
        }
}
