#include "chess.h"
#include "data.h"
#include "book.h"

#ifdef _LINUX
#include <string.h>
#endif

#define CONVERT(x) (( (7-(x / 8)) * 16 ) | (x & 7))
//====================================================================
//global GetBookMove() translates the board position to CBookPos and
//calls CBook::GetBookMove() for move.
//====================================================================

static CBook book;    //we need one CBook at global scope ...

void GetBookM(char * answer) {
	CBookPos bp;        //and one CBookPos to hold current position
	//char answer[8] = "";
	//s_eng *pe = pe1;
	char c = 0;
	int i, b, s;
	bp.bk_color = (char)side;          //color moving
	bp.bk_ep_target = 0;
	if(enpassant) bp.bk_ep_target = (char)CONVERT(enpassant);   //enpassant target
	for (i = 0; i < 64; i++) {
		b = board.square[CONVERT(i)].ptype;               //b = Bruja piece value
		s = board.square[CONVERT(i)].color;
		switch (b) {
	case EMPTY:
		c = 0;                    //c = CBook piece value
		break;
	case PAWN:
		c = 1;
		break;
	case KNIGHT:
		c = 2;
		break;
	case BISHOP:
		c = 3;
		break;
	case ROOK:  //rook is the only piece that requires work
		c = 4;    //assume a normal rook.  see if it can castle
		if (s == BLACK) {
			if (((i==56) && (castle & 8)) ||
				((i==63) && (castle & 4))) c = 7;
		} else {
			if (((i==0) && (castle & 2)) ||
				((i==7) && (castle & 1))) c = 7;
		}
		break;
	case QUEEN:
		c = 5;
		break;
	case KING:
		c = 6;
		break;
		}
		if (s == BLACK) c += 8;        //add 8 if black piece
		bp.bk_board[i] = c;           //place piece on board
	} //for board()

	//Translation complete.
	//caller must verify validity of returned move
	strcpy(answer, book.GetBookMove(&bp));
	
}
