#include "chess.h"
#include "data.h"
#include "weights.h"

#ifdef _LINUX
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#define CLK_TCK _SC_CLK_TCK
#endif

/*
    chess
	chess winboard
	chess personality
    chess winboard personality
	chess testsuite seconds
	chess personality testsuite seconds
	
*/
int main(int argc, char *argv[])
{
    int a=1, e=0, i=1, wb=0; // console mode - print copyright and instructions
	char suite[FILENAME_MAX] = ".\\tests\\";
	
	read_ini_file("default.ini"); // just read in defaults and change later

	ifstream test;
    
	logfile.open("log.txt");
	
	while(a < argc){
		if(!strcmp(argv[a], "winboard")) {a++; wb=1; continue;}
		if(!strcmp(argv[a], "xboard")) {a++; wb=2; continue;}
		if(atoi(argv[argc-1])>0){
			i = atoi(argv[argc-1]);
			if(--argc > 1){ 
				strcat(suite, argv[argc-1]);
				strcat(suite, ".epd");
				test.open(suite);
				if(test.is_open()){
					test.close();
					argc--;
					wb = 3;
				}else { e=1; break; }
			}else { e=1; break; }
			continue;
		}
		
		test.open(argv[a]);
		if(test.is_open()){
			test.close();
			a++;
			read_ini_file(argv[a]);
			continue;
		}else { e=1; break; }
	}

	if(e){
		puts("usage: ges [winboard/xboard] [person.ini] [testsuite seconds]");
		logfile.close();
		exit(0);
	}
		
	init_data();
	hashtable.resize(main_hash_entries);
	phashtable.resize(pawn_hash_entries);
	
	if(wb==0){
		cout << "GES_134 JA by David B Weller 2005\n\ntype: help for instructions\n\n";
	}
	if(wb==3){
		run_suite(suite, i * CLK_TCK, 60);
		logfile.close();
		exit(0);
	}


	winboard();

	logfile.close();
	exit(0);
  }
