#include "chess.h"
#include "data.h"
#include "search.h"

/*
	simply detirmine if position is MATE or MATE in 1 for side to move
*/

int mate_search(int alpha, int beta, int depth){
	if(ply >= MAXPLY-2) return 0;
	int incheck = board.incheck();
	if(depth < 1 && !incheck) return 0; // not currently mated
	tree.gen();
	int val = alpha, legal = 0;
	
	cMOVE * cm = tree.nextmove[ply-1];
    while(cm < tree.nextmove[ply]){
		if(!incheck || pseudoe[128+board.pieces[side][KING]-cm->to]){ // pseudo legals
			if(board.domove(cm)){ // legal
				if(depth) val = -mate_search(-beta, -alpha, depth - 1);
				else {board.unmove(); return 0;}// we have a legal move
				if(val > alpha){
					if(val >= beta) {board.unmove(); return val;}
					alpha = val;
				}
				legal++;
				board.unmove();
			}
		}
		cm++;
	}
	if(!legal){
		if(incheck) alpha = -MATE+(ply-1);
		else alpha = 0;
	}
	return alpha;
}