//#define BASECAPSCORE 975 // Q lost to P == 100  R lost to M == 800
//#define MAXHISTSCORE 900 // BEST history cut-off == 900  
// under-promo     losing moves   zero  lost caps  history even and winning caps
//  -1000     -975 -500 -325 -100  0    100 ... 800  900   975 ... 1950
//               castling   60/65 
//                  losing moves 

/*  
    Captures scored according to estimated win - loss
    [+150-975= -875 ...+150+325-500 = -25 .. 0 .. +150 .. +1125
    Non-Caps scored by historic value        0 ..+128
    Augments to main scores factors:
        PcSq diff -10 - 10
        Flight 0 10 30 50
            -10 to 60
*/
#define BASECAPSCORE 150 // even and winning caps get no history boost. smallest loss = 175
#define MAXHISTSCORE 128u //  32768  // >> 8 == 128

/*
-losers . ptype . psquare . history . misc . enprise . winners
<= -25    0 - 5   +-12*     0 - 128    **    +++

* pawns +24 
** castles, pawn27th
+++  see below
*/
//#define CAPVALQ  180
//#define CAPVALR  170
//#define CAPVALM  160
//#define CAPVALP  150

/*
	win loss
	+R  -Q = -475 +150 -325
	+P  -M = -225 +150 -75
	+M  -R = -175 +150 -25
*/

// loss
#define FRIGHTQ  QUEEN_VAL // 975 //600 //180 //240 // 
#define FRIGHTR  ROOK_VAL // 500 //300 //170 //190 // 
#define FRIGHTM  KNIGHT_VAL // 325 //180 //160 //170 // 
#define FRIGHTP  PAWN_VAL // 100 //60  //150 //150 //  

// since undefended pieces are gobbled up QUICK at next ply, why speculate?
// also, interposing moves can save queen and rook too
// many are defended - this seems to be a waste of test
// But, in the 'crazy' tree where much nonsense is investigated it is 
// probably more often true than not: we must move enprise pieces
#define FLIGHTQ  90 //900 // 0 // 45 //  190 //  
#define FLIGHTR  40 //400 // 0 // 25 //  180 //   
#define FLIGHTM  15 //170 // 0 // 16 //  170 //  
#define PROMO2QSCORE 1025 //160 // 20 //875 //  140 //
#define PAWN27SCORE  10 //30 // 130 //130
#define UNDERPROMOTE -1000
#define CASTLES  20 // 140 //0 //  was 190
 
