#include "chess.h"
#include "data.h"

// find lone pawn on board and return result of pawn race
int cBOARD::find_pawn(){
    int sq, i;
    i = 1;
    do{
        if((sq = pieces[side][i]) & 0x88);
        else if(square[sq].ptype == PAWN)
            return eval_pawn_race(sq);
        if(i == 8) break;
        i++;
    }while(1);    
    i = 1;
    do{
        if((sq = pieces[xside][i]) & 0x88);
        else if(square[sq].ptype == PAWN)
            return -eval_pawn_race(sq);
        if(i == 8) break;
        i++;
    }while(1);
    return 0; // should not get here
}
    
int cBOARD::eval_pawn_race(int pawn){
    int c = square[pawn].color;
    int o = c ^ 1;
	int pf = pawn & 7;
    int goodk = pieces[c][KING];
    int goodk2p = manhattan[128+pawn-goodk]-(side == c);
	int badk = pieces[o][KING];
    int badk2p = manhattan[128+pawn-badk]-(side == o); // enemy king is adjusted for stm
    int queeningsq = 112 * (c == BLACK) + pf;
	int goodk2q = manhattan[128+queeningsq-goodk]-(side==c);
	int badk2q = manhattan[128+queeningsq-badk]-(side == o);
	
	int dist2q = pawn >> 4;
    if(c == WHITE){
        if(goodk == pawn - 16) dist2q++;
        else if(dist2q == 6) // pawn at home and can jump 2
            if(goodk != pawn - 32) dist2q--;
    }else{// c == BLACK         
        dist2q = 7 - dist2q;
        if(goodk == pawn + 16) dist2q++;
        else if(dist2q == 6) // pawn at home and can jump 2
            if(goodk != pawn + 32) dist2q--;
    }
    
	//dist2q -= (side==c);

	/*
	cout << "pawn: " << pawn << " queens at: " << queeningsq << " in " << dist2q << " moves\n"
		<< "good king: " << goodk << " is " << goodk2p << " from pawn and " << goodk2q << " from queening square\n"
		<< "bad king: " << badk << " is " << badk2p << " from pawn and " << badk2q << " from queening square\n";
	//*/

	// enemy king outside square of pawn - clearly wins
    if(badk2q > dist2q) return 500 - dist2q;
    
    
	
    // clearly drawn [bad king not possibly prevented from capture]
    if(badk2p+2 <= goodk2p){
        return 0;
    }    
    
    // see if bad king approaches thru pawn attack squares making it 
	// effectively 1 more sq away
    if(c == WHITE){
        if(badk < pawn-14) // at least 15 less
            badk2p += ((pawn - badk)%17 == 0 || (pawn - badk)%15 == 0);
    }
    else{
        if(badk > pawn+14) // at least 15 greater
            badk2p += ((badk - pawn)%17 == 0 || (badk - pawn)%15 == 0);
    }    
    
    // clearly drawn [bad king still much closer to pawn]
    if(badk2p+1 <= goodk2p){
        return 0;
    }    
    // recap: kings near equidistant to pawn && 
    // pawn cant run. ie, king is in 'square of pawn'
    
    // rook pawn? 
	//kings must be on same side of pawn, so..
    
    int isrookpawn = (pf == 0 || pf == 7);
    
    if(badk2p+1 <= goodk2p + isrookpawn){
        return 0;
    }
        
    //*
    if(isrookpawn){
        if(badk2q - 1 - (dist2q == 1) >= goodk2q && ((goodk & 7) != pf))
            return 500 - dist2q;
        else return 0;
    }//*/
    

	//if king leads pawn by any # [but 1 unless pawn on 5th]
    int goodkf = goodk & 7;
    if(goodkf >= pf-1 && goodkf <= pf+1){
        if(c == WHITE){
            if(goodk < pawn)
                if(pawn < 64 || (goodk>>3) != (pawn>>3)-1)
                    return 500 - dist2q;
        }else{ //if(c == WHITE){
            if(goodk > pawn)
                if(pawn > 63 || (goodk>>3) != (pawn>>3)+1)
                    return 500 - dist2q;
        }
    }    
    // otherwise...        
    return PAWN_VAL + passed_pawn[7-dist2q];
}
