#include "chess.h"
#include "data.h"

#ifdef _LINUX
#include <string.h>
#endif


void cBOARD::setup(char * fen){
    char p, t[]="kqrbnpKQRBNP";
    //char * z;
    int j, i=-1, f=0, nextwpn = 1, nextbpn = 1;
    int nextwpc = 15, nextbpc = 15;
    int s=0;
    for(int k=0; k<128; k++){ // clear board
        square[k].put(NONE, EMPTY, CAPTURED);
    }
    for(int k=0; k<16; k++){
        pieces[WHITE][k] = OFFBOARD;
        pieces[BLACK][k] = OFFBOARD;
    }
//    for(int k=0; k<6; k++){
//        pcount[WHITE][k] = 0;
//        pcount[BLACK][k] = 0;
//    }
    castle = 0;  // start w/o/ castle rights
    fifty = 0;
	move50 = 100;
    enpassant = 0;
    //hascastled = 0;
    material[WHITE]=0;
    material[BLACK]=0;
	force[WHITE]=0;
	force[BLACK]=0;
    //init_hashtable(); // zero's all depths
    //mindex[0]=0;
    while(fen[++i]){
        p=fen[i];
        if(p==' '){ 
            f++; 
            continue;
        }
        //*
        if(p==';'){
            //fen[i]=0;
            continue;
        }
        //*/
        switch(f){
            case 0: // placing pieces
                if(p=='\\'){ 
                    s &= 0x80;
                    s += 16;
                    break;
                }
                if(p>'0' && p<'9'){ 
                    s+=(p-'0');
                    break;
                }
                j=0;
                do{
                    if(p==t[j]) break;
                }while(++j<12);
                if(j == 12) break;
                if(j>5){
                    if(j==6){
                        pieces[WHITE][KING] = s;
                        square[s].put(WHITE, KING, KING);
                    }
                    else if(j==11){
                        pieces[WHITE][nextwpn] = s;
                        square[s].put(WHITE, j-6, nextwpn++);
                        material[WHITE]+=matval[j-6];
					}
                    else{
                        pieces[WHITE][nextwpc] = s;
                        square[s].put(WHITE, j-6, nextwpc--);
                        material[WHITE]+=matval[j-6];
						force[WHITE]+=forceval[j-6];
                    }
                    //pcount[WHITE][j-6]++;
                }
                else{
                    if(j==0){
                        pieces[BLACK][KING] = s;
                        square[s].put(BLACK, KING, KING);
                    }
                    else if(j==5){
                        pieces[BLACK][nextbpn] = s;
                        square[s].put(BLACK, j, nextbpn++);
                        material[BLACK]+=matval[j];
                    }
                    else{
                        pieces[BLACK][nextbpc] = s;
                        square[s].put(BLACK, j, nextbpc--);
                        material[BLACK]+=matval[j];
						force[BLACK]+=forceval[j];
                    }
                    //pcount[BLACK][j]++;
                }
                
                s++;
                break;
            case 1:  // set side to move
                if(p=='w'){
                    side=WHITE;
                    xside=BLACK;
                }
                if(p=='b'){
                    side=BLACK;
                    xside=WHITE;
                }
                break;
            case 2:  // set castle rights
                if(p=='K') castle |=1;
                if(p=='Q') castle |=2;
                if(p=='k') castle |=4;
                if(p=='q') castle |=8;
                break;
            case 3:  //  enpassant square
                if(strchr("abcdefgh", p) != NULL)
                    enpassant = p - 'a';
                if(strchr("12345678", p) != NULL)
                    enpassant += 16*(7-(p - '1'));
                break;
            //default:
                //fen[i+1]=0;
            
        }
        if(s&8) s+=8;
    }
    key = hash();
    init_affected();
    clear_historic();
    hashtable.clear();
    phashtable.clear();
	ply = 1;
	tree.nextmove[0] = tree.moves;
	gamestack.hply = 1;
	tree.gen();
}// end setboard()

void cBOARD::buildepd(char * p){
    char t[]="kqrbnpKQRBNP";
    int i = 0, spcs = 0;
    do{
        if(i&8){
            if(spcs){
               *p = '0' + spcs;
                spcs = 0;
                p++;
            }
            *p = '/';
            p++;
            i += 8;
        }        
        if(square[i].ptype == EMPTY) spcs++;
        else{
            if(spcs){
                *p = '0' + spcs;
                spcs = 0;
                p++;
            }    
            *p = t[(square[i].color^1) * 6 + square[i].ptype];
            p++;
        }
        if(i == 119){
            if(spcs) *p++ = '0' + spcs;
            break;
        }    
        i++;
    }while(1);
    *p++ = ' ';
    if(side == WHITE) *p++ = 'w';
    else *p++ = 'b';
    *p++ = ' ';
    if(castle & 15){
        if(castle & 1) *p++ = 'K';
        if(castle & 2) *p++ = 'Q';
        if(castle & 4) *p++ = 'k';
        if(castle & 8) *p++ = 'q';
    }else *p++ = '-';   
    *p++ = ' ';
    if(enpassant){
        *p++ = 'a' + (enpassant & 7);
        *p++ = '0' + (7 - (enpassant >> 4));
    }else *p++ = '-';    
    *p = 0;
}        
