/* 
    sort
*/

#include "chess.h"
#include "data.h"

//*

// if any piece-type could attack the king from this square
// is_pseudo_evasion()
// if distance to attacker == 1 step, we cannot intervene
// nor if double attacked
// so the Q. is moving to this sq, a pseudo evasion, is:
// king move? yes
// double attack? no
// not on king? no
// ---- no double and is on king ---
// is_capture yes
// not_adjacent_attacker y
// no
int onking(int x){
    int y = board.pieces[side][KING];
    int dx = (x & 7) - (y & 7);
    if(dx == 0) return 1; // vertical
    int dy = (x >> 4) - (y >> 4);
    if(dy == 0) return 1; // horizontal
    dx = (dx < 0)? -dx : dx;
    dy = (dy < 0)? -dy : dy;
    if(dx == dy) return 1; // diags
    if(dx+dy == 3) return 2; // knights
    return 0;
}//*/


int cMOVELIST::filterlegals(){
	cMOVE * m = nextmove[ply-1];
	cMOVE * l = nextmove[ply];
	int n = 0;
    while(m < l){
		//if(pseudoe[128 + board.pieces[side][KING] - m->to]){ //onking(m->to)
		if(m->is_pseudo_evasion()){
            if(board.domove(m)){
				board.unmove();
				n++;
				m++;
			}
			else{ // this move in not legal, so copy last move here
				l--;
				*m = *l; 
			}
		}
		else{ // this move isnt even pseudo-evasion, same..
			l--;
			*m = *l;
		}
	}
	nextmove[ply] = l;
	return n;
}

// 8+16+32 = 56 
/*
int onking(int x){
	if((x&7)==(y&7)) return 1;
	if((x&56)==(y&56)) return 1;
	if((x-y)%15 == 0) return 1;
	if((x-y)%17 == 0) return 1;
	return 0;
}//*/

void cMOVELIST::isortall(){
    cMOVE cm;
    cMOVE * j;
    cMOVE * i;
    cMOVE *start = nextmove[ply-1] , *end = nextmove[ply];
    j = (start + 1); // start @ 2nd item
    while(j < end){ // 
        cm = *j; // save key
        i = (j - 1); //
        while(i >= start && i->score < cm.score){// simply changed compare
            *(i+1) = *i;
            i--;
        }
        *(i+1) = cm;
        j++;
    }
}


//void cMOVELIST::isortone(cMOVE * s){
//    cMOVE t;
//    cMOVE * mi = (s+1);
//    cMOVE * end = nextmove[ply];
//    while(mi < end){
//        if(mi->score > s->score){
//            t = *s;
//            *s = *mi;
//            *mi = t;
//        }
//        mi++;
//    }
//}

void cMOVELIST::isortone(cMOVE * s){
    cMOVE * t = s;
    cMOVE * mi = s;
    cMOVE * end = nextmove[ply];
	while(++mi < end) if(mi->score > t->score) t = mi;
	if(t != s){
		cMOVE temp = *s;
		*s = *t;
		*t = temp;
	}
}

void cMOVELIST::list(){
    gen();
	if(board.incheck()) filterlegals();
    isortall();
    cMOVE * i = nextmove[ply-1];
    while(i < nextmove[ply]){
        i->print();
        cout << " " << i->score << "\t";
        i++;
    }
	cout << endl;
    /*side ^= 1;
    xside ^= 1;
    gen();
    isortall();
    i = nextmove[ply-1];
    while(i < nextmove[ply]){
        i->print();
        cout << i->score << "\n";
        i++;
    }
    side ^= 1;
    xside ^= 1;*/
}

