#include "chess.h"
#include "data.h"
#include "search.h"
#include "weights.h"

#ifdef _LINUX
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#define CLK_TCK _SC_CLK_TCK
#endif


cMOVE think(int maxt, int ovrt, int maxd, char * answers){ // , 
    int ext;//, extended; //d = 1, 
    vbs = -NFINITY; // very best score at start
    int las = 0, s;
	int wasright = 0; // for test suites
    rootalpha = -NFINITY, rootbeta = NFINITY;
    long elapsed_time=0, last_time=0, ct;
	float bf;
	abf = 0;
    ct = clock();
	st = ct + maxt - CLK_TCK/4; // 1/4th second margin
    stopsearch = 0;
    ply = 1;
    idepth = 0;
    int depth_complete = 0;
    
	age_historic();  // must do this. cant keep increasing maxhist[] for ever
	
	//if(fifty == 0){
	//	hashtable.clear();
	//	//phashtable.clear(); piece captures and castles dont count: rely on lock
	//}
	//else 
		hashtable.inc_age();
    
    
    cMOVE bm, vbm, lbm;    
    cMOVE *cm, *pbm = &bm;
    for(int x = 0; x < MAXPLY; x++){
        for(int y = 0; y < MAXPLY; y++)
            pv[x][y].set(OFFBOARD, OFFBOARD,NOMOVE,0);
        pvl[x]=0;
        //tree.killer1[x].from = 0x88;
    }
    
    pvl[ply] = ply;
    
    tree.hashmove[ply].to = 0x88;
	tree.killer1[ply+1].to = 0x88;
	tree.killer1[ply].to = 0x88;
	tree.killer2[ply+1].to = 0x88;
	tree.killer2[ply].to = 0x88;

    int easymove = 0;
	
    //*
    int val;
    cHASHENTRY * he = hashtable.probe();
    if(he != NULL){
        tree.hashmove[ply].from = he->bm.from;
        tree.hashmove[ply].to = he->bm.to;
        tree.hashmove[ply].mtype = he->bm.type;
        //*
        val = he->value;
        if (ABS(val) > MATE-300) {
            if (val > 0) val-=(ply-0);
            else val+=(ply-0);
        }
		vbm = tree.hashmove[ply];
		vbs = val;
        switch(he->data & 3){
            case FAIL_LOW_UPPER:
                rootbeta = val + ASPIRWIN;
				break; 
            case FAIL_HIGH_LOWER:
                rootalpha = val - ASPIRWIN;
                //idepth = he->depth-1;
                break;
            case EXACT_PV:
				vbs = val; // prevents from having no score at time-out and thinking is lost
                rootalpha = val - ASPIRWIN;
                rootbeta = val + ASPIRWIN;
                //idepth = he->depth-1;
                extract(&tree.hashmove[ply]);
				//easymove++;
				break;
            }
        //*/
    }
    //*/
    
    
    tree.nextmove[0] = tree.moves;
    tree.gen();
	if(board.incheck()) tree.filterlegals();    
    tree.isortall();
	
	if(vbm.to == 0x88) // so we dont time out, and return nothing
		vbm = *tree.nextmove[ply-1];
    
    int flags = 1;
    int foundpv = 0;
    int firstone;
    int alpha;
	int best;
    int legal;
	int goodmove;//, easymove=0;
    nodes = 1;
    qnodes = 0;
    qdepth = 0;
    fh1 = 1;
    fhn = 1;
    tot_p7_ext = 0;
    tot_mt_ext = 0;   
    tot_ck_ext = 0;
    tot_nm_red = 0;
	tot_fut_cut = 0;
    tot_nm_fal = 0;
    tot_1reply = 0;
    tot_delay = 0;
	tot_recap_ext = 0;
    good_delay = 0;

	
	do{  
        foundpv = 0;
        firstone = 1;
        legal = 0;
		goodmove = 0;// count the number of 'acceptable' moves
        
        // level all previous iteration scores so that
        // the scores do not interfere with current
        cm = tree.nextmove[ply-1];
        while(cm < tree.nextmove[ply]){
            cm->score = -NFINITY;
            cm++;
        }
        
		
		alpha = rootalpha; 
		best = -NFINITY;    
        
        cm = tree.nextmove[ply-1];
        while(cm < tree.nextmove[ply]){
			//*
			if(post){
				printf("%2d[%2d]   %6d %3d/%3d ", idepth+1, qdepth, elapsed_time/10, cm-tree.nextmove[ply-1]+1, tree.nextmove[ply] - tree.nextmove[ply-1]);
				cm->print();
				cout << "  \r";
			}//*/ 
			
			/* works, but ...
			cm->to_string(buffer);
			printf("\nstat01: %u %u %d %u %u %s\n",
               (unsigned int)(elapsed_time / 1000),
               nodes+qnodes,
               idepth+1,
               cm-tree.nextmove[ply-1]+1,
               tree.nextmove[ply] - tree.nextmove[ply-1],
               buffer);
			fflush(stdout);//*/
            
#ifdef TRACEr
            cm->to_string(buffer);
#endif
            if(board.domove(cm)){
#ifdef TRACEr
                logfile << idepth << ":" << buffer;
#endif
                legal++;
				ext = 0;
				
				firstone = (nodes+qnodes)/1000;
                
				// checking move
                if(board.incheck()) 
                    ext = 1;

                // pawn 2 7th extension
                else if(board.gamestack.was_p27()) 
					ext = 1;
                
                
				if(idepth == 0)
					s = -isearch(-NFINITY, NFINITY);

                //*
                else if(foundpv){// legal > 1){//
                    s = -pvsearch(-alpha-1, -alpha, idepth + ext, 0, flags);
					if (!stopsearch){// && s > rootalpha){ //unecessary
						if(s > alpha && s < rootbeta){
                            s = -pvsearch(-rootbeta, -alpha, idepth + ext, 0, flags);
                        }
                    }    
                }
                else //*/
                    s = -pvsearch(-rootbeta, -alpha, idepth + ext, 0, flags);
                
                    
                board.unmove();
                
                if(stopsearch) break; // score is bogus 0

#ifdef TRACEr
                logfile << "=" << s << " ";
#endif				

                if(idepth) cm->score = ((nodes+qnodes)/1000)-firstone;
				else{
					cm->score = s;
					// count good moves
					//cout << "s = " << s << " rootalpha = " << rootalpha << " ";
					//cm->print();
					//cout << endl;
					goodmove += (int)(s > rootalpha);
				}

                elapsed_time = clock()-ct;

				if(s > best){
					best = s;
					bm = *cm;
					pbm = cm;

					if(s > alpha){
						if(s >= rootbeta){
							if(bm.mtype > PROMO2Q) bump(cm, idepth + 1 + ext);
#ifdef TRACEr
							logfile << ply << ":" << "fail_high:" << legal << endl;
#endif
							break;
						}
						alpha = s;
						foundpv = 1; // moved to before fh for time out situation

						// update the PV 
						pv[ply][ply] = bm;
						for (int j = ply + 1; j < pvl[ply + 1]; ++j)
							pv[ply][j] = pv[ply + 1][j];
						pvl[ply] = pvl[ply + 1];

						/*
						printf("%2d %5d %6d %9ld ", idepth+1, s, elapsed_time/10, nodes+qnodes);
						bm.print();
						//printf("%s\r", buffer);
						printf("\r");
						fflush(stdout);
						//*/
					}
				}
			}    
            else cm->score = -NFINITY;
            cm++;
        }
        
#ifdef TRACEr
                logfile << endl;
#endif

        if(!legal){
            vbm.to = 0x88;
			return vbm;
        }


        
		
		if(best > rootalpha){ //including fail high
			
			    vbm = bm; // remember very best move,
				vbm.score = best; // remember score in case we exit due to mate
                vbs = best; // and very best score
                pbm->score = 1000000;
                tree.isortall();
            
			if(best < rootbeta){
            
            	printf("%2d %5d %6d %9ld ", idepth+1, vbs, elapsed_time/10, nodes+qnodes);
                stuff(idepth+1, best);
                printf("\n");
                fflush(stdout);
                
				// exit on time-out, mates, and forced moves
				if(stopsearch){
					// didnt finish resolving a failure
					if(las == 0 && ovrt > 0 ){
						st += ovrt;
						stopsearch = 0;
						ovrt = 0;
						continue;
					}else break;
				}

				if(elapsed_time > maxt) break;// true if we were on overtime

                if(idepth > 1 && ABS(best) > MATE-idepth) break;
                if(legal < 2) break;

				if(answers == NULL){ // not doing test suite

					if(easymove){
						if(bm.is_equal(&lbm)){
							if(elapsed_time > (maxt/5)
								&& best > board.gamestack.top()->score-40
								) break; // and we have used 1/3 time
						}else easymove = 0;// else quite looking for easy move
					}
					// if all moves but 1 lose according to csearch()
					if(goodmove == 1 && idepth == 0){
						lbm = bm;
						easymove = 1;
					}

				}

				//calc branching factor according to times used for each iteration
                if(last_time){
					bf = (float)(elapsed_time / last_time);
					abf += bf;
				}
				last_time = elapsed_time;
                
				
				// set and clamp bounds
				rootalpha = best - ASPIRWIN;
                rootbeta = best + ASPIRWIN;
                if(rootalpha < -NFINITY) rootalpha = -NFINITY;
                if(rootbeta > NFINITY) rootbeta = NFINITY;
                
				depth_complete = idepth;
				idepth++;
                las = 1; // flag as pv iteration

								
				if(answers != NULL){ // we're doing test suite
					vbm.to_san(buffer);
					if(strstr(answers, buffer)) wasright++;
					else wasright = 0;
					if(wasright > 2) break;
				}//*/
				

			}else{   // FAIL-HIGH  -FEW searched, lower bound set, pv set
                
				if(las);// rootalpha = best-1;//;// rootalpha = alpha-ASPIRWIN;//;//
                else 
					rootalpha = -NFINITY; 
				rootbeta = NFINITY;
				printf("%2d %5d %6d %9ld ", idepth+1, vbs, elapsed_time/10, nodes+qnodes);
                bm.print();
                printf(" <+>\n");
                fflush(stdout);
                las = 0;
				//easymove = 0;

				hashtable.store(idepth+1, best, FAIL_HIGH_LOWER, &bm);
				
				// exit on time-out, mates we can resolve
				if(stopsearch) break;
            }
            
        }else{   // FAIL-LOW    
            /*
				EVERY time we do NOT finish our first move, we're going to 'fail-low'
				because best = -NFINITY until 1st move is searched
				but if we were trying to resolve a previous fail [las == 0]
				or we have finished our 1st move and still failed low [best > -INF]
				then we need to keep searching
			*/	
			if(stopsearch){
				if((las == 0 || best > -NFINITY) && ovrt > 0){
					st += ovrt;
					stopsearch = 0;
					ovrt = 0;
					rootalpha = -NFINITY;
					continue;
				}else break;
			}

			if(las);// rootbeta = best+1;//;// rootbeta = alpha+ASPIRWIN;// ;//
            else 
				rootbeta = NFINITY;
			rootalpha = -NFINITY;

            printf("%2d %5d %6d %9ld  <->", idepth+1, best, elapsed_time/10, nodes+qnodes);
            printf("\n");
            fflush(stdout);
			
			easymove = 0;
			
			hashtable.store(idepth+1, best, FAIL_LOW_UPPER, &bm);
			
			las = 0;
        }
		

#ifdef TRACEr        
        logfile << endl;
#endif        
    }while(idepth <= maxd);

    if(depth_complete>1) abf /= (depth_complete-1);
    else abf = -1;
       
    if(post){
		printf("Knps: %ld[r=%ld q=%ld(%ld%%)]\nfh=%d%% bf=%.2f\next: ck=%d p7=%d mt=%d 1r=%d re=%d delay=%d good=%d \nred: nm=%d fc=%d zg=%d \nht=%d%%\n", 
            (nodes+qnodes)/((clock()-ct)|1), 
            nodes, 
            qnodes, 
            100*qnodes/(nodes+qnodes),
            100*fh1/fhn, 
            abf,
            tot_ck_ext, 
            tot_p7_ext, 
            tot_mt_ext,
            tot_1reply,
			tot_recap_ext,
            tot_delay,
            good_delay,
            tot_nm_red,
			tot_fut_cut,
            tot_nm_fal, 
            100*hashtable.stored/hashtable.main_hash_size);
    }

    vbm.score = vbs;
    
	//*
	board.buildepd(buffer);
	logfile << buffer << endl;
	vbm.to_string(buffer);
	logfile << buffer << " " << vbm.score << endl;
    logfile << "Knps: " << (nodes+qnodes)/((clock()-ct)|1)  
            << " nodes: " << nodes 
            << " qnodes: " << qnodes 
            << "(" << 100*qnodes/(nodes+qnodes) << "%)"
            << "\ndepth: " << depth_complete << "(" << qdepth << ")"
            << "\nfail-high 1: " << 100*fh1/fhn
			<< " branch factor: " << abf
			<< "\nextensions: check: " << tot_ck_ext 
            << " p7: " << tot_p7_ext 
            << " mate: " << tot_mt_ext
            << " 1reply: " << tot_1reply
			<< " recap: " << tot_recap_ext
            << " delay: " << tot_delay << "(" << good_delay << ")"
            << "\nreductions: null: " << tot_nm_red
            //<< " zugzwang: " << tot_nm_fal
			<< " futile: " << tot_fut_cut
            << "\nhash usage: " << 100*hashtable.stored/hashtable.main_hash_size << "%\n\n";
    //*/
    
	return vbm;
}   
