

#ifdef _LINUX
#include <unistd.h>
#include <strings.h>
//#include <sys/types.h>
//#include <sys/time.h>
#else
#include <windows.h>
#endif

#include <stdio.h>
#include "chess.h"



#ifdef _LINUX
// Non-windows version 
int Bioskey(void) {
  fd_set readfds;
  struct timeval timeout;
   
  FD_ZERO(&readfds);
  FD_SET(fileno(stdin), &readfds);
  // Set to timeout immediately 
  timeout.tv_sec = 0;
  timeout.tv_usec = 0;
  select(16, &readfds, 0, 0, &timeout);
   
  return (FD_ISSET(fileno(stdin), &readfds));
}

#else //*/
/* Windows-version */
//#include <time.h>
#include <conio.h>
int Bioskey(void) {

  static int init = 0, pipe;
  static HANDLE inh;
  DWORD dw;
  // If we're running under XBoard then we can't use _kbhit() as the input commands
  // are sent to us directly over the internal pipe 
  if (XBoard) {
#if defined(FILE_CNT)
    if (stdin->_cnt > 0) return stdin->_cnt;
#endif
    if (!init) {
      init = 1;
      inh = GetStdHandle(STD_INPUT_HANDLE);
      pipe = !GetConsoleMode(inh, &dw);
      if (!pipe) {
        SetConsoleMode(inh, dw & ~(ENABLE_MOUSE_INPUT | ENABLE_WINDOW_INPUT));
        FlushConsoleInputBuffer(inh);
      }
    }
    if (pipe) {
      if (!PeekNamedPipe(inh, NULL, 0, NULL, &dw, NULL)) return 1;
      return dw;
    }
    else {
      GetNumberOfConsoleInputEvents(inh, &dw);
      return dw <= 1 ? 0 : dw;
    }
  }
  else

    return _kbhit();
}

#endif


unsigned int popcount16(unsigned int b){
    unsigned int u = b;
    u = ((u&0x55555555) + ((u>>1)&0x55555555));
    u = ((u&0x33333333) + ((u>>2)&0x33333333));
    u = ((u&0x0f0f0f0f) + ((u>>4)&0x0f0f0f0f));
    u = ((u&0x00ff00ff) + ((u>>8)&0x00ff00ff));
    return u;
}

unsigned int BSR(unsigned int Bits)
{
__asm bsr eax,[Bits]
}
