#include <string.h>
#include <signal.h>

#include "chess.h"
#include "data.h"


#ifdef _LINUX
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#define CLK_TCK _SC_CLK_TCK
#endif



//#include "book.h"
//CBook book;
void GetBookM(char *);
void playself(int);

static const char *help[] = {
    //"analyze - run search",
    "help - displays this list",
    "new - game",
    "black - computer plays black",
    "white - computer plays white",
    "go - computer plays side to move",
	"force - computer off",
    "bye - quit program",
    "quit - quit program",
    "display - board",
    //"eval - print static score",
    //"evalsuite file - evaluate positions in .\\tests\\file.epd",
	"hint - gives idea of best move",
    //"level",
    "list - legal moves",
    //"nopost",
    "say - displays board after each turn with extra search info",
    "nosay - stop output of board and extra info",
    //"otim",
    //"perft d - run perft depth d",
	//"post",
    //"read",
    "undo - take back one move",
    "remove - go back 1 full turn [2 moves]",
    //"runsuite file - search positions in .\\tests\\file.epd",
    "st m - set milliseconds for GES to 'think'",
    "sd d - set 'moves ahead' GES should search",
    "setboard fen - set board to FEN string",
    "fen - display fen string",
	"flip - exchange positions",
    "phash kbytes - set pawn hash",
    "hash kbytes - set hash size",
    //"time",
    //"xboard",
	//"zobrist",
    NULL
};

void winboard(){
    int computer = NONE;
    int max_time = 30 * CLK_TCK;
	int o_time = 0;
	int ovr_time = 0;
	int reg_time = 30 * CLK_TCK;
	int my_turns;
	int max_deep = 60;
    int inc_time = 0;
    int moves_per_period = 0;
    int moves_remaining = 0;
    int time_per_period = 0;
	int temp, i;
	bool use_book = true;
    char line[256], command[256], buf[256], buf2[5], buf3[5], buf4[5];
    
	cMOVE m;
    signal(SIGINT, SIG_IGN);
	
	board.setup("rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq -");
	
	//GetBookM(line);

    do{
        fflush(stdout);
		if(post) board.display();
		
		if (side == computer) {
			
			//*
			if(use_book && board.gamestack.hply < 40){
				GetBookM(line);
				if(s2move(line, m)){
					board.domove(&m);
					if(time_per_period){
						moves_remaining--;
						if(moves_remaining < 1)
							moves_remaining = moves_per_period * 2;
					}
					printf("move %s\n", line);
					fflush(stdout);
					ply = 1;
					qdepth = 1;
					tree.gen();
					continue;
				}//else cout << "******** " << line << endl;
			}//*/

			// level 40 5 0  level 2 1 0  level 0 5 0 or level 0 :30 5 etc.
			// level  0 2 0 - sudden death
			
			if(time_per_period){
				if(moves_per_period)
					my_turns = (moves_remaining+side)/2;
				else{ // sudden death - always 30 moves remain
					my_turns = 30;
					max_time += (max_time - o_time)/3; // adjust for opponents time
				}
				//ovr_time = max_time / my_turns ;
				//max_time -= ovr_time;
				//reg_time = max_time / my_turns;
				reg_time = max_time / my_turns;
				max_time -= reg_time;
				ovr_time = max_time/2;
			}else{
				reg_time = max_time;
				ovr_time = 0;
			}
			
			logfile << "max_time = " << max_time
				<< " reg_time = " << reg_time
				<< " ovr_time = " << ovr_time 
				<< " opponents time = " << o_time 
				<< " moves_remaining = " << moves_remaining << endl;
			
			m = think(reg_time, ovr_time, max_deep, NULL);
			
			// it was side's turn and side had no move because it was mated
			// or, side mated and now it is xside's turn
            if (m.to == 0x88) {
				if(board.control[board.pieces[side][0]] & mask[side]){
					if(side == WHITE) printf("0-1 {Black mates}");
					else printf("1-0 {White mates}");
				}else printf("1/2-1/2 {Stalemate}");
				printf("\n");
				computer = EMPTY;
				continue;
			}
			
			if(m.score < -700 && o_time > moves_remaining * 10){
				if(side == WHITE)
					printf("0-1 {White resigns}\n");
				else
					printf("1-0 {Black resigns}\n");
				computer = EMPTY;
				continue;
            }

			if(m.score < 500
				&& o_time > moves_remaining * 10 // unless opponent is running out of time
				&& board.gamestack.hply > 80 
				&& board.gamestack.progress(m.score) < 11  // in 10 turns
				){
					printf("offer draw\n");
					fflush(stdout);
			}
			
            //*
            line[0] = (char)((m.from & 7)+ 'a');
            line[1] =(char)(8 - (m.from >> 4)+ '0');
            line[2] =(char)((m.to & 7)+ 'a');
            line[3] =(char)(8 - (m.to >> 4)+ '0');
            line[4] = 0;
            printf("move %s\n", line);
            fflush(stdout);
            
            if(board.domove(&m));
			else{
				printf("error - bad move from search ... aborting");
				fflush(stdout);
				logfile << "bad move recieved from think()";
				return;
			}
            
            // or, side mated and now it is xside's turn
            if (m.score == 9999) {
				if(side == WHITE) printf("0-1 {Black mates}");
				else printf("1-0 {White mates}");
				printf("\n");
				computer = EMPTY;
				continue;
			}
			
			if(fifty >= move50){
                printf("1/2-1/2 {Draw by 50 move rule}\n");
                computer = EMPTY;
				continue;
            }
            
            if(board.gamestack.rep2()){
                printf("1/2-1/2 {Draw by repetition}\n");
                computer = EMPTY;
				continue;
            }        
                        
            if(time_per_period){
                moves_remaining--;
				//cout << moves_remaining << endl;
                if(moves_remaining < 1)
                    moves_remaining = moves_per_period * 2;
				//cout << moves_remaining << endl;
				//fflush(stdout);
            }

            ply = 1;
			qdepth = 1;
			tree.gen();
			continue;
		}// if side == computer
		
		if (!fgets(line, 256, stdin))
			continue;
		
        if (line[0] == '\n')
			continue;
		
        sscanf(line, "%s", command);
		
        if (!strcmp(command, "analyze")){
            m = think(max_time, 0, max_deep, NULL);
            continue;
        }
        
		if (!strcmp(command, "xboard")){
           printf("feature done=0\n");                
			printf("\n");
			XBoard = true;
			continue;
		}

	if (!strcmp(command, "protover")) {
			sscanf(line, "protover %d", &temp);
			printf("feature setboard=1\n");
                        printf("feature reuse=0\n");
                        printf("feature colors=1\n");
                        printf("feature pause=0\n");
                        printf("feature sigint=0\n");
                        printf("feature sigterm=0\n");
                        printf("feature time=1\n");
                        printf("feature analyze=1\n");
                        printf("feature done=1\n");
			continue;
		}

		if (!strcmp(command, "new")) {
			board.setup("rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq");
			tree.gen();
			computer = BLACK;
			logfile << endl << "**** NEW GAME ****" << endl;
			continue;
		}
		
		if (!strcmp(command, "quit") || !strcmp(command, "exit")) {
                  exit(0);
                  }
		
		if (!strcmp(command, "force")) {
			computer = NONE;
			continue;
		}
		if (!strcmp(command, "white")) {
			if(side == BLACK) key = ~key;
            side = WHITE;
			xside = BLACK;
			tree.gen();
			computer = BLACK;
			continue;
		}
		if (!strcmp(command, "black")) {
			if(side == WHITE) key = ~key;
            side = BLACK;
			xside = WHITE;
			tree.gen();
			computer = WHITE;
			continue;
		}
		if (!strcmp(command, "st")) {
			sscanf(line, "st %d", &max_time);
			max_time *= CLK_TCK;
			ovr_time = 0;
			time_per_period = 0; // flags no level
            max_deep = 60;
            continue;
		}
		// sent by winboard once at start  eg.,  level 2 1 0
		if (!strcmp(command, "level")) {
			sscanf(line, "level %d %d %d", &moves_per_period, &time_per_period, &inc_time);
			if(time_per_period){
				//if(moves_per_period == 0) moves_per_period = 60;
				moves_remaining = moves_per_period*2; //convert turns to moves
			}
			max_deep = 60;
			continue;
		}
		
		/*
       if (!strcmp(command, "read")) {
            ifstream is("history.dat", ios::binary);
            is.read(htable, 64*64*sizeof(int));
            is.close();
            ifstream is2("hash.dat", ios::binary);
            is2.read(hashtable, TABLESIZE*sizeof(tHASHDATA));
            is2.close();
            continue;
        }
        */
		if (!strcmp(command, "sd")) {
			sscanf(line, "sd %d", &max_deep);
			max_deep--;
			max_time = (1 << 30)-1;
			time_per_period = 0; // flags no level
			continue;
		}
		
		if (!strcmp(command, "help")) {
			size_t index;
			
			for (index = 0; help[index]; index++)
			   puts(help[index]);
			continue;
		}
		
		/*
			time is sent before opponent's move, hence moves remaining
			is one too many
		*/

		if (!strcmp(command, "time")) {
			sscanf(line, "time %d", &max_time);
			max_time *= CLK_TCK/100; //convert to milliseconds
	        max_deep = 60;
            continue;
		}
		
		if (!strcmp(command, "otim")) {
			sscanf(line, "otim %d", &o_time);
			o_time *= CLK_TCK/100; //convert to milliseconds
			continue;
		}

		if (!strcmp(command, "go")) {
			computer = side;
			continue;
		}
		if (!strcmp(command, "hint")) {
			m = think(max_time, 0, max_deep, NULL);
			//printf("Hint: %s\n", move_str(pv[0][0].b));
			line[0] = (char)((m.from & 7)+ 'a');
            line[1] =(char)(8 - (m.from >> 4)+ '0');
            line[2] =(char)((m.to & 7)+ 'a');
            line[3] =(char)(8 - (m.to >> 4)+ '0');
            line[4] = 0;
            printf("Hint: %s\n", line);
            continue;
		}
		if (!strcmp(command, "undo")) {
			if (board.gamestack.hply < 2)
				continue;
			board.unmove();
			ply = 1;
			tree.gen();
			continue;
		}
		if (!strcmp(command, "remove")) {
			if (board.gamestack.hply < 3)
				continue;
			board.unmove();
			board.unmove();
			ply = 1;
			tree.gen();
			continue;
		}
		if (!strcmp(command, "post")) {
			//post = 2;
			continue;
		}
		if (!strcmp(command, "nopost")) {
			//post = 0;
			continue;
		}
		if (!strcmp(command, "say")) {
			post = 2;
			continue;
		}
		if (!strcmp(command, "nosay")) {
			post = 0;
			continue;
		}
		if (!strcmp(command, "book")) {
			use_book = true;
			continue;
		}
		if (!strcmp(command, "nobook")) {
			use_book = false;
			continue;
		}
		
		if (!strcmp(command, "setboard")) {
			sscanf(line, "setboard %s %s %s %s", buf, buf2, buf3, buf4);
			strcat(buf, " ");
			strcat(buf, buf2);
			strcat(buf, " ");
			strcat(buf, buf3);
			strcat(buf, " ");
			strcat(buf, buf4);
            board.setup(buf);
            continue;
		}
		
		if(!strcmp(command, "fen")){
		    board.buildepd(buf);
		    cout << buf << endl;
		    continue;
		}

		if(!strcmp(command, "flip")){
		    board.flip();
		    continue;
		}    
		
		if (!strcmp(command, "eval")) {
		    cout << board.evaluate() << endl;
		    continue;
        }
        
        if (!strcmp(command, "list")) {
		    tree.list();
		    continue;
        }
        
        if (!strcmp(command, "perft")) {
			sscanf(line, "perft %d", &temp);
			long tnow = clock();
			nodes = perft(temp);
            cout << nodes << " " << clock()-tnow << " " << nodes/(clock()-tnow) << endl;
			continue;
		}
        
		if (!strcmp(command, "search")) {
			sscanf(line, "search %d", &temp);
			ply = 1;
			stopsearch = 0;
			idepth = temp;
			qdepth = 0;
			st = clock() + 10000;
			cout << pvsearch(-NFINITY, NFINITY, temp, 0, 0) << endl;
			cout << qdepth << endl;
			continue;
		}

        if (!strcmp(command, "runsuite")) {
			sscanf(line, "runsuite %s", buf);
			buffer[0] = 0;
			strcat(buffer, ".\\tests\\");
			strcat(buffer, buf);
			strcat(buffer, ".epd");
			run_suite(buffer, max_time, max_deep);
			continue;
		}
		
		if (!strcmp(command, "evalsuite")) {
			sscanf(line, "evalsuite %s", buf);
			eval_suite(buf);
			continue;
		}
		
		if (!strcmp(command, "display")) {
		    board.display();
		    continue;
        }

		if (!strcmp(command, "zobrist")) {
		    cout << key << endl;
		    continue;
        }

		if (!strcmp(command, "bye")) return;

		if (!strcmp(command, "hash")) {
			sscanf(line, "hash %d", &temp);
			if(temp < 16 || temp > 256*1024){
				puts("enter size in Kbytes from 16 to 262144");
				continue;
			}
			temp *= 1024;
			temp /= sizeof(cHASHENTRY);
			i = 1;
			while((i << 1)-1 <= temp) i <<= 1;
			printf("main hash set to %d entries\n", i-1);
			hashtable.resize(i-1);
			continue;
		}

        if (!strcmp(command, "phash")) {
			sscanf(line, "phash %d", &temp);
			if(temp < 16 || temp > 256*1024){
				puts("enter size in Kbytes from 16 to 262144");
				continue;
			}
			temp *= 1024;
			temp /= sizeof(cPHASHENTRY);
			i = 1;
			while((i << 1)-1 <= temp) i <<= 1;
			printf("pawn hash set to %d entries\n", i-1);
			phashtable.resize(i-1);
			continue;
		}
		
		if (!strcmp(command, "computer")) {
			continue;
		}

		if (!strcmp(command, "hard")) {
			continue;
		}

		if (!strcmp(command, "easy")) {
			continue;
		}

		if (!strcmp(command, "random")) {
			continue;
		}
		
		if (!strcmp(command, "play")) {
			sscanf(line, "play %d", &temp);
			if(temp > 0 && temp < 256) playself(temp);
			continue;
		}

		if(!strcmp(command, "phist")){
			board.gamestack.print();
			continue;
		}

		
		if(line[0] >= 'a' && line[0] <= 'h' 
			&& line[1] >= '1' && line[1] <= '8' 
			&& line[2] >= 'a' && line[2] <= 'h' 
			&& line[3] >= '1' && line[3] <= '8'){

				if(s2move(line, m)){
					board.domove(&m);
					ply=1;
					tree.gen();

					if(time_per_period){
						moves_remaining--;
						if(moves_remaining < 1)
							moves_remaining = moves_per_period * 2;
					}
				}
				else{
					computer = NONE;
					printf("illegal move: %s", line);
				}
				continue;
		}

        printf("unkown command\n");
		//computer = EMPTY;
    
    }while(1);
}
